package entities;


import java.io.Serializable;
import java.util.UUID;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import org.hibernate.annotations.Cascade;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Proxy;
import org.hibernate.annotations.Type;

import com.fasterxml.jackson.annotation.JsonIdentityInfo;
import com.fasterxml.jackson.annotation.ObjectIdGenerators;


@Entity
@Table(name="\"DatasetProfile\"")
//@Proxy(lazy = false) 
@JsonIdentityInfo(generator=ObjectIdGenerators.PropertyGenerator.class, property="id")
public class DatasetProfile implements Serializable {
	
	
	private static final long serialVersionUID = 8203086344232867334L;

	public DatasetProfile () {}
	
	
	@Id
	@GeneratedValue
    @GenericGenerator(name = "uuid2", strategy = "uuid2")
    @Column(name = "\"ID\"", updatable = false, nullable = false, columnDefinition = "BINARY(16)")
	private UUID id;
	
	@Column(name = "\"Label\"")
	private String label;
    
	@OneToOne(fetch = FetchType.EAGER, mappedBy = "profile", cascade = CascadeType.ALL)
	private Dataset dataset;
	
	@OneToOne(fetch = FetchType.EAGER, cascade=CascadeType.ALL)
//	@Cascade(value=org.hibernate.annotations.CascadeType.ALL)
    @JoinColumn(name = "\"Ruleset\"", nullable = false)
	private DatasetProfileRuleset ruleset;
	
	
	@OneToOne(fetch = FetchType.EAGER, cascade=CascadeType.ALL)
//	@Cascade(value=org.hibernate.annotations.CascadeType.ALL)
    @JoinColumn(name = "\"Viewstyle\"", nullable = false)
	private DatasetProfileViewstyle viewstyle;
	

	@Type(type="typedefinition.XMLType")
	@Column(name = "\"Definition\"", columnDefinition = "xml", nullable = false)
	private String definition;

	public UUID getId() {
		return id;
	}

	public void setId(UUID id) {
		this.id = id;
	}

	public String getLabel() {
		return label;
	}

	public void setLabel(String label) {
		this.label = label;
	}


	public DatasetProfileRuleset getRuleset() {
		return ruleset;
	}

	public void setRuleset(DatasetProfileRuleset ruleset) {
		this.ruleset = ruleset;
	}
	

	public DatasetProfileViewstyle getViewstyle() {
		return viewstyle;
	}

	public void setViewstyle(DatasetProfileViewstyle viewstyle) {
		this.viewstyle = viewstyle;
	}

	public String getDefinition() {
		return definition;
	}

	public void setDefinition(String definition) {
		this.definition = definition;
	}

	public Dataset getDataset() {
		return dataset;
	}

	public void setDataset(Dataset dataset) {
		this.dataset = dataset;
	}

	
	
}
